using System;
using System.IO;
using System.Diagnostics;
using System.Threading;

 
namespace OrangejuiceElectronica {
	public class UrlToNix {
		public static string sFile="";
		public static bool bGood=false;
		public static int iFoundFiles=0;
		public static int iFoundUrls=0;
		public static string sLine="";
		public static string sLastComment="";
		public static string sMiniName="urltonix";
		public static string sMyName="UrlToNix";
		public static string sVersion="1.0-20070803";
		public static readonly string[] sarrAllowedLinks=new string[]{"htm","php","asp"};
		public static int iDone=0;
		public static string sMyNameFull {
			get {
				return sMyName+" "+sVersion;
			}
		}
		public static void Main(string[] sarrArg) {
			string sVerb="starting";
			try {
				int iArg=0;
				foreach (string sFile in sarrArg) {
					sVerb="p argument "+sFile;
					if ((!(sFile=="mono"&&iArg==0)) && (!(sFile=="mono"&&iArg==0)) && (sFile!=sMiniName) && (sFile!=sMiniName+".exe") && File.Exists(sFile)) {
						iFoundFiles++;
						sVerb="opening file "+sFile;
						StreamReader srNow=File.OpenText(sFile);
						int iLine=1;
						while (( sLine = srNow.ReadLine() ) != null ) {
							try {
								sVerb="processing line \""+sLine+"\"";
								while (sLine.StartsWith(" ")||sLine.StartsWith("\t")) sLine=sLine.Length>1?sLine.Substring(1):"";
								while (sLine.EndsWith(" ")||sLine.EndsWith("\t")) sLine=sLine.Length>1?sLine.Substring(0,sLine.Length-1):"";
								if (sLine.StartsWith("[")&&sLine.EndsWith("]")) {
									sVerb="processing comment"+iLine.ToString()+" of "+sFile+": \""+sLine+"\"";
									sLastComment="sLine";
								}
								else if (sLine!="") {// && !sLine.StartsWith("#")) {
									sVerb="processing non-blank line"+iLine.ToString()+" of "+sFile+": \""+sLine+"\"";
									int iSign=sLine.IndexOf("=");
									string sHref="href=\"";
									int iHref=sLine.IndexOf(sHref);
									int iHrefCloser=-1;
									if (iHref>=0) iHrefCloser=sLine.Substring(iHref+sHref.Length).IndexOf("\"")+(iHref+sHref.Length);
									string sCommand = "";
									int iUrl=sLine.IndexOf("http://");
									if (sLine.StartsWith("http://")) {
										sVerb="processing line "+iLine.ToString()+" of "+sFile+" which starts with \"http://\": \""+sLine+"\"";
										int iSpace=sLine.IndexOf(" ");
										sCommand=(iSpace>0)?sLine.Substring(0,iSpace):sLine;
									}
									else if (iHref>=0&&iHrefCloser>iHref) {//if (!sLine.StartsWith("http://")) {
											sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an href statement: \""+sLine+"\"";
											iHref+=sHref.Length;
											sCommand=sLine.Substring(iHref,iHrefCloser-iHref);
											if (!HasAllowedLink(sCommand)) {
												sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unusable href statement: \""+sLine+"\"";
												sCommand="";
											}
											else {
												sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has a usable href statement: \""+sLine+"\"";
											}
									}
									else if (sLine.ToUpper().StartsWith("URL=")) {
										sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has a standard URL= statement: \""+sLine+"\"";
										sCommand=((iSign+1<sLine.Length)?sLine.Substring(iSign+1):"");
									}
									else if (iUrl>=0) {
										sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unmarked link at index "+iUrl.ToString()+": \""+sLine+"\"";
										int iEnder=sLine.Substring(iUrl).IndexOf(" ")+iUrl;
										if (iEnder>iUrl) {
											string sTemp=sLine.Substring(0,iUrl)+"["+sMiniName+"-found-url-here-to-end-of-line]"+sLine.Substring(iUrl);
											sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unmarked link at character [index+1=]"+(iUrl+1).ToString()+" ending before ["+iEnder.ToString()+"]: \""+sTemp+"\"";
											sCommand=sLine.Substring(iUrl,iEnder-iUrl);
										}
										else {
											string sTemp=sLine.Substring(0,iUrl)+"["+sMiniName+"-found-url-here-to-end-of-line]"+sLine.Substring(iUrl);
											sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unmarked link at index [index+1=] "+(iUrl+1).ToString()+": \""+sTemp+"\"";
											sCommand=sLine.Substring(iUrl);
										}
									}
									if (sCommand!="") {
										sVerb="processing command \""+sCommand+"\" on line "+iLine.ToString()+" of "+sFile+": \""+sLine+"\"";
										iFoundUrls++;
										System.Diagnostics.Process proc = new System.Diagnostics.Process();
										proc.EnableRaisingEvents=false;
										//if (iSpace>-1) {
										//	sCommand=sLine.Substring(0,iSpace);
										//	sArgs=sLine.Substring(iSpace+1);
											proc.StartInfo.FileName=sCommand;
										//	proc.StartInfo.Arguments=sArgs;
										//}
										//else {
										//	proc.StartInfo.FileName=sLine;
										//}
										try {
											if (iDone==1) {
												Console.WriteLine();
												Console.WriteLine("   Waiting for browser (prevents \"Firefox is already open\" errors)...");
												Console.WriteLine();
												Thread.Sleep(7000); //allows browser to load before dumping more stuff into it and confusing it (i.e. prevents "firefox already running" errors)
											}
											iFoundUrls++;
											Console.WriteLine("   Telling computer to run: \""+sCommand+"\"");
											proc.Start();
											iDone++;
										}
										catch (Exception exn) {
											Console.WriteLine("   OS could not execute \""+sCommand+"\"");
											Console.WriteLine("      "+exn.ToString());
										}
										//proc.WaitForExit();
									}//end if sCommand!=""
									else Console.WriteLine("   NO URL in "+sFile+" LINE "+iLine.ToString());//+": "+sLine);
								}//end if not blank
							}
							catch (Exception exn) {
								Console.WriteLine("   Exception error while "+sVerb+".");
								Console.WriteLine();
								Console.WriteLine("   "+exn.ToString());
							}
							iLine++;
						}//end while ReadLine
						srNow.Close();
						if (iFoundUrls<=0) Console.WriteLine("   No lines were found except "+((sLastComment!="")?("comments (i.e. "+sLastComment+")"):"blanks")+" in "+sFile);
					}//end if parameter in sarrArg is not the program itself
					//else {
						//Console.WriteLine("The file was not found, so nothing was done.");
					//}
					iArg++;
				}//end foreach sFile in sarrArg
				if (iFoundFiles<=0) {
					Console.WriteLine();
					Console.WriteLine("   Welcome to "+sMyName);
					Console.WriteLine();
					Console.WriteLine();
					Console.WriteLine("   To use this program, type");
					Console.WriteLine();
					Console.WriteLine("      mono "+sMiniName+".exe filename.url");
					Console.WriteLine();
					Console.WriteLine("   where filename.url is the URL file that you want to execute");
					Console.WriteLine();
					Console.WriteLine("   OR");
					Console.WriteLine();
					Console.WriteLine("   create a \"File Association\" (i.e. in \"Settings\", \"Configure Konqueror\" in KDE browser)");
					Console.WriteLine("   for *.URL and *.url file masks and use \"mono ./"+sMiniName+".exe\"");
					Console.WriteLine("   as the preferred application where '.' is the directory");
					Console.WriteLine("   where "+sMiniName+".exe is located.");
					Console.WriteLine();
					Console.WriteLine("   TROUBLESHOOTING: after making the file association, make sure that");
					Console.WriteLine("   the full command for the preferred application is used");
					Console.WriteLine("   as of Konqueror 3.5.6-0.1.fc6, Konqueror reverts to using \"mono\",");
					Console.WriteLine("   so after setting the association you have to go back and re-add");
					Console.WriteLine("   the path to "+sMiniName+".exe after \"mono\" as shown above.");
					Console.WriteLine();
					Console.WriteLine("                     http://www.expertmultimedia.com/orangejuice/");
					Console.WriteLine();
				}
				bGood=iFoundUrls>0;
			}
			catch (Exception exn) {
				Console.WriteLine("   Exception error while "+sVerb+".");
				Console.WriteLine();
				Console.WriteLine("   "+exn.ToString());
			}
			//if (!bGood) Console.WriteLine("Finished unsuccessfully...");
			//Console.WriteLine("(Finished "+iCount.ToString()+" commands)");
			Console.WriteLine();
			Console.WriteLine("   Program Finished "+(bGood?"(Success)":"(nothing done)"));
			//Console.ReadLine();
			Console.WriteLine();
		}
		public static bool HasAllowedLink(string sUrl) {
			bool bFound=false;
			int iMinLoc=2; //i.e. allows 1.htm but not xhtm
			if (sUrl!=null && sUrl!="") {
				foreach (string sNow in sarrAllowedLinks) {
					if (sUrl.IndexOf(sNow)>=iMinLoc) {
						bFound=true;
						break;
					}
				}
			}
			return bFound;
		}
	}//end UrlToNix
}//end namespace
